export declare type Split<S extends string, Delimiter extends string> = S extends `${infer Head}${Delimiter}${infer Tail}` ? [Head, ...Split<Tail, Delimiter>] : S extends Delimiter ? [] : [S];
export declare type Join<Strings extends Readonly<Array<string | number>>, Delimiter extends string> = Strings extends [] ? '' : Strings extends [string | number] ? `${Strings[0]}` : Strings extends readonly [string | number, ...infer Rest extends Array<string | number>] ? `${Strings[0]}${Delimiter}${Join<Rest, Delimiter>}` : string;
declare const emptyObjectSymbol: unique symbol;
export declare type EmptyObject = {
    [emptyObjectSymbol]?: never;
};
declare type IsEqual<A, B> = (<G>() => G extends A ? 1 : 2) extends <G>() => G extends B ? 1 : 2 ? true : false;
declare type Simplify<T> = {
    [KeyType in keyof T]: T[KeyType];
};
declare type Filter<KeyType, ExcludeType> = IsEqual<KeyType, ExcludeType> extends true ? never : KeyType extends ExcludeType ? never : KeyType;
declare type Except<ObjectType, KeysType extends keyof ObjectType> = {
    [KeyType in keyof ObjectType as Filter<KeyType, KeysType>]: ObjectType[KeyType];
};
export declare type RequireAtLeastOne<ObjectType, KeysType extends keyof ObjectType = keyof ObjectType> = {
    [Key in KeysType]-?: Required<Pick<ObjectType, Key>> & // 1. Make `Key`'s type required
    Partial<Pick<ObjectType, Exclude<KeysType, Key>>>;
}[KeysType] & Except<ObjectType, KeysType>;
export declare type SetRequired<BaseType, Keys extends keyof BaseType> = Simplify<Except<BaseType, Keys> & Required<Pick<BaseType, Keys>>>;
export {};
//# sourceMappingURL=type-fest.d.ts.map